/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


#ifndef _SOCKIO_H
#define _SOCKIO_H

#include "wrapper.h"

extern int new_sock(void);
extern int bind_sock(int, int);
extern int connect_sock(int, struct sockaddr *,unsigned int);
extern int init_sock(struct sockaddr *, char *, int);
extern int brecv(int s, void *buf, int len);
extern int nbrecv(int s, void *buf, int len);
extern int brecv_timeout(int s, void *buf, int len, int timeout);
extern int bsend(int s, void *buf, int len);
extern int bsendv(int s, const struct iovec *vec, int cnt);
extern int nbsend(int s, void *buf, int len);
extern int get_sockopt(int s, int optname);
extern int set_tcpopt(int s, int optname, int val);
extern int set_sockopt(int s, int optname, int size);
extern int set_socktime(int s, int optname, int size);
extern int nbsendfile(int s, int f, int off, int len);
extern int connect_timeout(int s, struct sockaddr *saddrp, int len, int time_secs);


#endif
/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 * End:
 *
 * vim: ts=3
 */
