/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


/*
 * SOCKSET.H - defines and structures to translate generic socket selection
 *                routines into platform specific calls
 */

#ifndef _SOCKSET_H
#define _SOCKSET_H

/* TYPEDEFS */
typedef struct sockset sockset, *sockset_p;

/* INCLUDES */
#include "dfd_set.h"

/* STRUCTURES */
struct sockset {
	int max_index;
	dyn_fdset read; /* used to save set between selects */
	dyn_fdset write; /* used to save set between selects */
	dyn_fdset tmp_read; /* used to store results of last select */
	dyn_fdset tmp_write; /* used to store results of last select */
	struct timeval timeout;
};

/* PROTOTYPES */
extern void addsockrd(int, sockset_p);
extern void addsockwr(int, sockset_p);
extern void delsock(int, sockset_p);
extern int nextsock(sockset_p);
extern int dumpsocks(sockset_p);
extern void initset(sockset_p);
extern void finalize_set(sockset_p);
extern int check_socks(sockset_p, int);


#endif
/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 * End:
 *
 * vim: ts=3
 */

