/*
 * (C) 1995-2001 Clemson University and Argonne National Laboratory.
 *
 * See COPYING in top-level directory.
 */


#ifndef  LIB_H
#define  LIB_H

#include "config.h"

/* we want to have the 64-bit functions available but not change the existing 
 * functions; _LARGEFILE64_SOURCE accomplishes this.
 */
#define _LARGEFILE64_SOURCE

#include "meta.h"
#include "req.h"
#include "desc.h"
#include "debug.h"
#include "build_job.h"
#include "sockset.h"
#include "jlist.h"
#include "pvfs_config.h"



/*PROTOTYPES*/
int unix_lstat(const char *fn, struct stat *s_p);
int unix_stat(const char *fn, struct stat *s_p);
int unix_fstat(int fd, struct stat *s_p);

/* MGRCOMM.C and IODCOMM.C stuff */
int init_mgrconn(void);
void cleanup_mgrconn(void);
int send_mreq_saddr(struct sockaddr *saddr_p, mreq_p req_p, void *data_p, mack_p ack_p);


int init_iodtable(int _initial_entries, int _grow_amount);
void cleanup_iodtable(void);
int instantiate_iod_entry(struct sockaddr *saddr_p);
int add_iodtable(struct sockaddr *saddr_p);
int badiodfd(int fd);
int find_iodtable(struct sockaddr *saddr_p);
int getfd_iodtable(int slot);
int getslot_iodtable(int sockfd);
int shutdown_alliods(void);
int inc_ref_count(int slot);
int dec_ref_count(int slot);

char *dmeta2fname(dmeta_p);

int do_jobs_handle_error(jlist_p jl_p, sockset_p ss_p, int msec, int* badsock);
int do_jobs(jlist_p jl_p, sockset_p ss_p, int msec);
int do_job(int sock, jinfo_p j_p, sockset_p ss_p);

#endif
/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 *
 * vim: ts=3
 * End:
 */ 
