Summary: A kernel interface to the pvfs layer
Name: pvfs-kernel
Version: 1.5.3
%define rbase 0pre4
Release: %rbase 
Copyright: GPL
Group: System Environment/Base
#Source: ftp://ftp.parl.clemson.edu/pub/pvfs/pvfs-kernel-%{version}.tgz
Source: pvfs-kernel-%{version}.tgz
Source1: pvfs-kernel-pvfsd.rc
Prereq: initscripts
Requires: pvfs

BuildRoot: /var/tmp/%{name}-buildroot

%description
PVFS is a parallel file system for linux.  This kernel module provides an
alternative to glibc wrappers for interfacing with that file system.  

%package modules
Release: %{rbase}_%(uname -r | tr - _ )
Group: System Environment/Kernel
Summary: PVFS modules for Linux VFS layer

%description modules
The kernel-specific modules for the VFS interface

%prep
%setup -q -n pvfs-kernel-%{version}-pre4

%build
autoconf
# i'm giving no flags, because i'll skip the "make install" command
./configure
make

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p ${RPM_BUILD_ROOT}/lib/modules/`uname -r`/fs
cp pvfs.o ${RPM_BUILD_ROOT}/lib/modules/`uname -r`/fs

mkdir -p ${RPM_BUILD_ROOT}/usr/sbin
cp pvfsd ${RPM_BUILD_ROOT}/usr/sbin
mkdir -p ${RPM_BUILD_ROOT}/sbin
cp mount.pvfs ${RPM_BUILD_ROOT}/sbin

install -d ${RPM_BUILD_ROOT}/etc/rc.d/init.d
install -m 755 %{SOURCE1} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/pvfsd
%clean
rm -rf $RPM_BUILD_ROOT

%post 
rm -rf /dev/pvfsd && mknod /dev/pvfsd c 60 0
/etc/rc.d/init.d/pvfsd start
[ -x /sbin/chkconfig ] && /sbin/chkconfig --add pvfsd

%post modules
# only if not an upgrade
if [ $1 -eq 1 ]; then 
	# some module tricks:
	echo "alias char-major-60 pvfs" >> /etc/modules.conf
	echo "alias /dev/pvfsd pvfs" >> /etc/modules.conf
	# mapped mode is better, but will fall back to dynamic if not avaliable
	# actually, untill the mapped-mode kernel oopses are tracked down,
	# better used dynamic
	echo "options pvfs buffer=dynamic" >> /etc/modules.conf
	# and make sure the changes take effect
	# really can't use a /dev/pvfsd with different major number
	/sbin/depmod -a
fi

%preun 
# only if not an upgrade
if [ $1 -eq 0 ]; then 
	rm -rf /dev/pvfsd
	chkconfig --del pvfsd
fi

%preun modules
# only if not an upgrade
if [ $1 -eq 0 ]; then
	# undo our modules tricks
	perl -p -i -e "s/alias char-major-60 pvfs//" /etc/modules.conf
	perl -p -i -e "s/alias /dev/pvfsd pvfs//" /etc/modules.conf
	perl -p -i -e "s/options pvfs buffer=mapped//" /etc/modules.conf
fi

%files
%defattr(-,root,root)
%doc README 
/usr/sbin/pvfsd
/sbin/mount.pvfs
/etc/rc.d/init.d/pvfsd

%files modules
%defattr(-,root,root)
/lib/modules/*/fs/*

%define date    %(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} Plogic RPM Crew <rpms@plogic.com>
All people listed below can be reached at <cvs_login>@plogic.com

$Log: pvfs-kernel.spec,v $
Revision 1.3  2002/10/24 17:44:07  rbross
First of Murali's patches; this is mostly formatting stuff and include file
fixes.

Revision 1.1.1.1  2002/10/21 03:53:35  vilayann
PVFS-Kernel sources

Revision 1.2  2002/01/07 21:54:12  rbross
updated with latham's patch.

Revision 1.11  2001/12/21 18:06:28  rlatham
new upstream  version. properly handle upgrades

Revision 1.10  2001/09/11 23:25:27  rlatham
patch from pete wycoff for filldir_t change

Revision 1.9  2001/09/11 17:26:59  rlatham
buffer=dynamic is considered more stable than buffer=mapped

Revision 1.8  2001/09/11 17:16:37  rlatham
add devfs-friendly lines to modules.conf

Revision 1.7  2001/09/11 01:20:45  rlatham
no changes to spec file, but manually modprobe pvfs in pvfsd rc file: if the
system is devfsd-based, there will be no /dev/pvfsd to auto-trigger a
modprobe.

Revision 1.6  2001/08/21 16:39:19  rlatham
break up into pvfs-kernel and pvfs-kernel-modules.  reorg inspired by
scyld's changes to my spec file


* Fri Apr 27 2001 Rob Latham <rlatham@plogic.com>
- updated for new version
- modify conf.modules to help automate the pvfs funstuff

* Wed Nov 15 2000 Rob Latham <rlatham@plogic.com>
- first rpmming of pvfs-kernel
